<?xml version="1.0"?>

<!--
  Settings common to both Raven cameras.

  Based on dalsa_gige_driver mono_camera_priviliged.launch
  (Leaves off some unused arguments)
-->

<launch>
  <!-- These arguments are mandatory. -->
  <arg name="frame_id"/>
  <arg name="camera_info_url"/>

  <!-- Only one of these needs to be set. -->
  <arg name="serial_number" default=""/>
  <arg name="ip_address" default=""/>

  <!-- and these are optional (vary per-camera)-->
  <arg name="red_gain" default="1.1"/>
  <arg name="blue_gain" default="2.0"/>
  <!-- green gain is always 1.0 -->

  <!-- used for synchronizing the cameras -->
  <arg name="trigger_mode" default="fixedrate"/>
  <arg name="output1_mode" default="none"/>

  <!-- Fixed parameters that must be the same for both cameras. -->
  <!-- Target frame rate, 0 for as fast as possible -->
  <arg name="frame_rate" value="20" />

  <!-- In the current configuration, the cameras auto-adjust their
       exposure, so I'm not sure what these params actually do.. -->
  <arg name="digital_gain"  value="4.0" />
  <arg name="exposure_auto_max"  value="12000" />
  <arg name="gain_auto_max" value="32" />

  <arg name="output2_mode" value="none"/>
  <arg name="turbo_drive" value="true" />

  <node name="dalsa_driver" pkg="dalsa_gige_driver"
        type="dalsa_gige_node" output="screen"
        launch-prefix="dalsa_gige_grant" >

    <param name="serial_number" type="str" value="$(arg serial_number)" />
    <param name="ip_address" type="str" value="$(arg ip_address)" />
    <param name="frame_id"     value="$(arg frame_id)" />
    <param name="camera_info_url" value="$(arg camera_info_url)" />

    <param name="trigger_mode" value="$(arg trigger_mode)"/>
    <param name="output1_mode" value="$(arg output1_mode)"/>
    <param name="output2_mode" value="$(arg output2_mode)" />

    <param name="frame_rate"   value="$(arg frame_rate)" />
    <param name="turbo_drive"   value="$(arg turbo_drive)" />

    <param name="digital_gain"  value="$(arg digital_gain)" />
    <param name="exposure_auto_max"  value="$(arg exposure_auto_max)" />
    <param name="gain_auto_max" value="$(arg gain_auto_max)" />

    <param name="red_gain" value="$(arg red_gain)"/>
    <param name="blue_gain" value="$(arg blue_gain)"/>
  </node>
</launch>
